<template>
  <div class="topic-list">
    <LoadingSpinner v-if="loading" />
    <div v-if="loaded && topics.length === 0">No topics found.</div>
    <TopicListItem
      v-for="topic in topics"
      :key="topic.id"
      :topic="topic"
      @subscribed="onSubscribed"
      @unsubscribed="onUnsubscribed"
    />
    <PaginationNav
      v-if="showPagination"
      :total="total"
      :offset="offset"
      :limit="limit"
      singular="topic"
      plural="topics"
    />
  </div>
</template>

<script>
import { ref, computed, onMounted, watch } from 'vue'
import { useStore } from 'vuex'
import { Constants, LoadingSpinner, PaginationNav, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import TopicsApi from '../api/topics-api.js'
import TopicListItem from './topic-list-item.vue'

export default {
  name: 'TopicList',
  components: {
    LoadingSpinner,
    PaginationNav,
    TopicListItem,
  },
  props: {
    route: { type: Object, default: null },
    section: { type: String, default: '' }, // Section
    username: { type: String, default: '' }, // Topic started by user
    offset: { type: Number, default: 0 },
    limit: { type: Number, default: Constants.pagination.defaultPageLimit },
    subscribed: { type: Boolean, default: null },
  },
  setup(props) {
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const topicsApi = new TopicsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const topics = ref([])
    const total = ref(0)

    const showPagination = computed(() => {
      return loaded.value && total.value > props.limit
    })

    const isLoggedOn = computed(() => {
      return Boolean(store.state.identity.session.userId)
    })

    const onSubscribed = (id) => {
      topics.value.find((x) => x.id === id).subscribed = true
    }

    const onUnsubscribed = (id) => {
      topics.value.find((x) => x.id === id).subscribed = false
    }

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      topics.value = []

      try {
        const response = await topicsApi.fetchAsync({
          expand: 'all',
          offset: props.offset,
          limit: props.limit,
          section: props.section,
          username: props.username,
          subscribed: props.subscribed,
        })

        total.value = parseInt(response.headers['x-total-count'])
        topics.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the topics.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    watch(
      () => props.offset,
      async () => {
        await loadAsync()
      }
    )

    watch(
      () => props.limit,
      async () => {
        await loadAsync()
      }
    )

    // Reload topics list if logged in or out.
    // This forces an update of the .subscribed field.
    watch(isLoggedOn, async () => {
      await loadAsync()
    })

    return {
      loading,
      loaded,
      topics,
      total,
      showPagination,
      isLoggedOn,
      onSubscribed,
      onUnsubscribed,
    }
  },
}
</script>
